
#ifndef HELIND_LCD_LORA
#define HELIND_LCD_LORA

#include "U8g2lib.h"

//U8G2_ST7920_128X64_2_HW_SPI u8g(U8G2_R0,53); 
U8G2_ST7920_128X64_1_8080 u8g(U8G2_R0, 42, 43, 44, 45, 46, 47, 48, 49, /*enable=*/ 41 /* A4 */, /*cs=*/ U8X8_PIN_NONE, /*dc/rs=*/ 39 /* A3 */, /*reset=*/ 24 /* A1 */);  // Remember to set R/W to 0 

int8_t  MENU_ITEMS=4;

int8_t PERF_MENU_ITEMS = 4;


volatile int8_t menu_page=0; // sehifeleri deyismek ucun istifade olunan parametr
volatile int8_t selected_value=0;

float max_min_array[4]={0.0,0.0,0.0,0.0};  // [0]-Max Voltage,[1]-Min Voltage, [2]- Max Speed,[3]-Min Speed
volatile uint16_t freq_vals[4] = { 1,75,45,1 };

const char *menu_strings[4] = {  "Max Voltage", "Min Voltage", "Max Speed", "Min Speed" };
const char *sensor_menu[4]= {"Wind Sensor", "Wattmeter","Wind alarm","Voltage alarm"};
const char *modbus_menu[3]= {"Slave id", "Wattmeter config,Lora Set"};
const char *wattmeter_menu[3] = {"Scan","ID","Shunt val"};
const char* freq_menu_strings[4] = { "Freq. Braking", "Max Freq", "Min Freq", "Num of Dipoles" };
const char* braking_menu_strings[6] = { "Res. Braking", "Phase braking","BRAKE TIMER","LoRa", "LoRa Braking","LoRa Timer"};

char buffer[10];

int str_len=0;
volatile int8_t menu_current = 0;
volatile int8_t select=0;
volatile uint8_t wind_sensor=0;
volatile uint8_t watt_meter =0;
volatile uint8_t voltage_al =0;
volatile uint8_t wind_al =0;
volatile uint8_t freq_braking_val = 0;
volatile uint8_t lora_timer = 0, brake_timer = 0;
uint8_t wattmeter_slave_id = 1;
uint8_t wattmeter_shunt_val = 3;
volatile uint8_t slave_id = 1;
void uiSetup_page1(void)
{	
u8g.begin();
u8g.setFontMode(0);
	 u8g.setFont(u8g2_font_6x13_tr);
}

void drawSensorFull(void) 
{
 uint8_t i, h;
  u8g2_uint_t w, d;

  u8g.setFont(u8g2_font_6x13_tr);
  u8g.setFontRefHeightText();
  u8g.setFontPosTop();
 u8g.setDrawColor(1);
  u8g.drawStr(0,0,"Sensor Settings");
  h = u8g.getAscent()-u8g.getDescent();
  w = u8g.getWidth();
  uint8_t met_flags[4]={wind_sensor,watt_meter,wind_al,voltage_al};
  for( i = 0; i < PERF_MENU_ITEMS; i++ ) 
  {
    	d = (w-u8g.getStrWidth(sensor_menu[i]))/2;
    	u8g.setDrawColor(1);
    	if ( i == menu_current ) 
		{
      		u8g.drawBox(0, i*h+13, w, h);
      		u8g.setDrawColor(0);
    	}

    	u8g.drawStr(5, i*h+13, sensor_menu[i]);
    	str_len=u8g.getStrWidth(sensor_menu[i]);
    	u8g.drawStr(10+str_len, i*h+13,(met_flags[i]!=0)?"ON":"OFF");

  }
}

#define PARAMON 1
#define PARAMOFF 2
#define PARAMAUTO 3
uint8_t loramode = PARAMOFF, brstate = PARAMAUTO, pbrstate = PARAMAUTO, lobstate = PARAMAUTO;
enum brakingmenudefs {
    BRSTATE, PBRSTATE,BRAKETIMER,LORAMODE,LOBSTATE,LORATIMER,LAST_ENT
};
void drawBrakingMenu(void)
{
    uint8_t i, h;
    u8g2_uint_t w, d;

    u8g.setFont(u8g2_font_6x10_tr);
    u8g.setFontRefHeightText();
    u8g.setFontPosTop();
    u8g.setDrawColor(1);
    u8g.drawStr(0, 0, "Braking Settings");
    h = u8g.getAscent() - u8g.getDescent();
    w = u8g.getWidth();
    uint8_t met_flags[LAST_ENT] = { brstate,pbrstate,brake_timer,loramode,lobstate ,lora_timer};
    for (i = 0; i < LAST_ENT - (loramode == PARAMOFF)*2; i++)
    {
        d = (w - u8g.getStrWidth(braking_menu_strings[i])) / 2;
        u8g.setDrawColor(1);
        if (i == menu_current)
        {
            u8g.drawBox(0, i * h + 10, w, h);
            u8g.setDrawColor(0);
           if(menu_current==BRAKETIMER||menu_current==LORATIMER) if (select != 0) u8g.drawStr(115, i * h + 10, "<<");
        }

        u8g.drawStr(5, i * h + 10, braking_menu_strings[i]);
        str_len = u8g.getStrWidth(braking_menu_strings[i]);


        switch (i) {
        case BRSTATE:
        case PBRSTATE:
        case LORAMODE:
        case LOBSTATE:        
            switch (met_flags[i]) {
        case PARAMON: u8g.drawStr(10 + str_len, i * h + 10, "ON"); break;
        case PARAMOFF:  u8g.drawStr(10 + str_len, i * h + 10, "OFF"); break;
        case PARAMAUTO: u8g.drawStr(10 + str_len, i * h + 10, "AUTO"); break;
        }
            break;
        case BRAKETIMER:
        case LORATIMER: 
            memset(buffer, '\0', sizeof(buffer));
            snprintf(buffer, sizeof(buffer), "%d", met_flags[i]);
            u8g.drawStr(10 + str_len, i * h + 10, buffer);

            break;
        }

    }
}

void modbus_conf_screen() {
  uint8_t i, h;
  u8g2_uint_t w, d;

  u8g.setFont(u8g2_font_6x13_tr);
  u8g.setFontRefHeightText();
  u8g.setFontPosTop();
  u8g.setDrawColor(1);
  u8g.drawStr(0,0,"Modbus Settings");
  h = u8g.getAscent()-u8g.getDescent();
  w = u8g.getWidth();
  for( i = 0; i < 3; i++ ) 
  {
    d = (w-u8g.getStrWidth(modbus_menu[i]))/2;
    	u8g.setDrawColor(1);
    	if ( i == menu_current ) 
		{
      		u8g.drawBox(0, i*h+13, w, h);
      		u8g.setDrawColor(0);
			if ( select !=0&&i==0) u8g.drawStr(115, i*h+13,"<<");
    	}
		if(i == 0)sprintf(buffer,"%d",slave_id);
    	u8g.drawStr(5, i*h+13, modbus_menu[i]);
    	str_len=u8g.getStrWidth(menu_strings[i]);
		if(i == 0)u8g.drawStr(10+str_len, i*h+13,buffer);

  }


}

void wattmeter_conf_screen(){
	uint8_t i, h;
  u8g2_uint_t w, d;

  u8g.setFont(u8g2_font_6x13_tr);
  u8g.setFontRefHeightText();
  u8g.setFontPosTop();
  u8g.setDrawColor(1);
  u8g.drawStr(0,0,"Wattmeter Settings");
  h = u8g.getAscent()-u8g.getDescent();
  w = u8g.getWidth();
  for( i = 0; i < 3; i++ ) 
  {
    d = (w-u8g.getStrWidth(wattmeter_menu[i]))/2;
    	u8g.setDrawColor(1);
    	if ( i == menu_current ) 
		{
      		u8g.drawBox(0, i*h+13, w, h);
      		u8g.setDrawColor(0);
			if (select != 0 &&i==0) u8g.drawStr(115, i*h+13,"<<");
    	}
        uint8_t datarr[3] = { 0,wattmeter_slave_id,wattmeter_shunt_val };
        sprintf(buffer,"%d",datarr[i]);

        u8g.drawStr(5, i * h + 13, wattmeter_menu[i]);
        str_len = u8g.getStrWidth(wattmeter_menu[i]);
        if (i != 0) {
            
            
          if(i==1)  u8g.drawStr(10 + str_len, i * h + 13, buffer); 
          if (i == 2) {
              if (select != 0) u8g.drawStr(115, i * h + 13, "<<");
              switch (wattmeter_shunt_val) {
              case 0:u8g.drawStr(10 + str_len, i * h + 13, "100A"); break;
              case 1:u8g.drawStr(10 + str_len, i * h + 13, "50A"); break;
              case 2: u8g.drawStr(10 + str_len, i * h + 13, "200A"); break;
              case 3:u8g.drawStr(10 + str_len, i * h + 13, "300A"); break;
              
              }
          }
        }

  }
	
}
void drawMenuFull(void) 
{
 uint8_t i, h;
  u8g2_uint_t w, d;

  u8g.setFont(u8g2_font_6x13_tr);
  u8g.setFontRefHeightText();
  u8g.setFontPosTop();
 u8g.setDrawColor(1);
  u8g.drawStr(0,0,"Parameter Settings");
  h = u8g.getAscent()-u8g.getDescent();
  w = u8g.getWidth();
  for( i = 0; i < MENU_ITEMS; i++ ) 
  {
    	d = (w-u8g.getStrWidth(menu_strings[i]))/2;
    	u8g.setDrawColor(1);
    	if ( i == menu_current ) 
		{
      		u8g.drawBox(0, i*h+13, w, h);
      		u8g.setDrawColor(0);
      		if (select != 0) u8g.drawStr(115, i*h+13,"<<");
    	}
    	dtostrf(max_min_array[i],4,1,buffer);
    	
    	u8g.drawStr(5, i*h+13, menu_strings[i]);
    	str_len=u8g.getStrWidth(menu_strings[i]);
    	u8g.drawStr(10+str_len, i*h+13,buffer);

  }
}

void drawFreq(void)
{
    uint8_t i, h;
    u8g2_uint_t w, d;

    u8g.setFont(u8g2_font_6x13_tr);
    u8g.setFontRefHeightText();
    u8g.setFontPosTop();
    u8g.setDrawColor(1);
    u8g.drawStr(0, 0, "Freq Settings");
    h = u8g.getAscent() - u8g.getDescent();
    w = u8g.getWidth();
    uint8_t numof = 0;
    if (freq_vals[0] != 0) { numof = 4; }
    else numof = 1;
    for (i = 0; i < numof; i++)
    {
        d = (w - u8g.getStrWidth(freq_menu_strings[i])) / 2;
        u8g.setDrawColor(1);
        if (i == menu_current)
        {
            u8g.drawBox(0, i * h + 13, w, h);
            u8g.setDrawColor(0);

            if (select != 0&&menu_current!=0) u8g.drawStr(115, i * h + 13, "<<");
        }
        memset(buffer, 0, sizeof(buffer));
        if (i != 0) { sprintf(buffer, "%hu", freq_vals[i]); }
        else { sprintf(buffer, "%s",((freq_vals[0]!=0)?"On":"Off") ); }
        u8g.drawStr(5, i * h + 13, freq_menu_strings[i]);
        str_len = u8g.getStrWidth(freq_menu_strings[i]);
        u8g.drawStr(10 + str_len, i * h + 13, buffer);

    }
}

void drawMenu(void) 
{
  uint8_t i, h;
  u8g2_uint_t w, d;

  u8g.setFont(u8g2_font_6x13_tr);
  u8g.setFontRefHeightText();
  u8g.setFontPosTop();
  u8g.setDrawColor(1);
  u8g.drawStr(0,0,"Parameter Settings");
  h = u8g.getAscent()-u8g.getDescent();
  w = u8g.getWidth();
  for( i = 0; i < MENU_ITEMS-2; i++ ) 
  {
    d = (w-u8g.getStrWidth(menu_strings[i]))/2;
    	u8g.setDrawColor(1);
    	if ( i == menu_current ) 
		{
      		u8g.drawBox(0, i*h+13, w, h);
      		u8g.setDrawColor(0);
      		if ( select !=0) u8g.drawStr(115, i*h+13,"<<");
    	}
    	dtostrf(max_min_array[i],4,1,buffer);
    	
    	u8g.drawStr(5, i*h+13, menu_strings[i]);
    	str_len=u8g.getStrWidth(menu_strings[i]);
    	u8g.drawStr(10+str_len, i*h+13,buffer);

  }
}

void sensorMenu(void) 
{
  uint8_t i, h;
  u8g2_uint_t w, d;

  u8g.setFont(u8g2_font_6x13_tr);
  u8g.setFontRefHeightText();
  u8g.setFontPosTop();
  u8g.setDrawColor(1);
  u8g.drawStr(0,0,"Sensor Settings");
  h = u8g.getAscent()-u8g.getDescent();
  w = u8g.getWidth();
  i=0;
    	  for( i = 0; i < 2; i++ ) 
  { 
		d = (w-u8g.getStrWidth(sensor_menu[i]))/2;
    	u8g.setDrawColor(1);
    	if ( i == menu_current ) 
		{  	
      		u8g.drawBox(0, i*h+13, w, h);
			 if ( wind_sensor) {
		u8g.setDrawColor((i==0)?0:1); 
				 u8g.drawStr(115, 0*h+13,"on");
				 }
      		else{ 
			u8g.setDrawColor((i==0)?0:1); 
			u8g.drawStr(110, 0*h+13,"off");
			}
			
			
			if  (watt_meter) {
				u8g.setDrawColor((i==1)?0:1); 
				u8g.drawStr(115, 1*h+13,"on");
				}
      		else {
				u8g.setDrawColor((i==1)?0:1); 
				u8g.drawStr(110, 1*h+13,"off");
				}
    	}
    	u8g.drawStr(5, i*h+13, sensor_menu[i]);
    	str_len=u8g.getStrWidth(sensor_menu[i]);
  }
}

float mapfloat(float x, float in_min, float in_max, float out_min, float out_max)
{
 return (x - in_min) * (out_max - out_min) / (in_max - in_min) + out_min;
}

//ICONS for main menu

//battery icons

const uint8_t battery[] PROGMEM = {
   0xfc, 0x00, 0x7e, 0x00, 0xec, 0x00, 0x7e, 0x00, 0xc4, 0x00, 0x66, 0x00,
   0xef, 0xff, 0xff, 0x01, 0xff, 0xff, 0xff, 0x01, 0x03, 0x00, 0x80, 0x01,
   0x03, 0x00, 0x80, 0x01, 0x03, 0x00, 0x80, 0x01, 0x03, 0x00, 0x80, 0x01,
   0x03, 0x00, 0x80, 0x01, 0x03, 0x00, 0x80, 0x01, 0x03, 0x00, 0x80, 0x01,
   0x03, 0x00, 0x80, 0x01, 0x03, 0x00, 0x80, 0x01, 0x03, 0x00, 0x80, 0x01,
   0x03, 0x00, 0x80, 0x01, 0x03, 0x00, 0x80, 0x01, 0x03, 0x00, 0x80, 0x01,
   0x03, 0x00, 0x80, 0x01, 0x03, 0x00, 0x80, 0x01, 0x03, 0x00, 0x80, 0x01,
   0x03, 0x00, 0x80, 0x01, 0x03, 0x00, 0x80, 0x01, 0x03, 0x00, 0x80, 0x01,
   0x03, 0x00, 0x80, 0x01, 0x03, 0x00, 0x80, 0x01, 0xff, 0xff, 0xff, 0x01,
   0xff, 0xff, 0xff, 0x01  }; 

const uint8_t battery2[] PROGMEM = {
 0xff, 0xff, 0x1f, 0xff, 0xff, 0x1f, 0xff, 0xff, 0x1f
    }; 




//wind turbine icons

const uint8_t wind1[] PROGMEM = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x01, 0x00, 0x00, 0x80, 0x01, 0x00,
   0x00, 0x80, 0x01, 0x00, 0x00, 0x80, 0x01, 0x00, 0x00, 0x80, 0x01, 0x00,
   0x00, 0x80, 0x01, 0x00, 0x00, 0xc0, 0x03, 0x00, 0x00, 0xc0, 0x03, 0x00,
   0x00, 0xc0, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x01, 0x00,
   0x00, 0xc0, 0x03, 0x00, 0x00, 0xd0, 0x0b, 0x00, 0x00, 0x9c, 0x39, 0x00,
   0x00, 0x3e, 0x7c, 0x00, 0x00, 0xbf, 0xf9, 0x00, 0x80, 0x87, 0xe1, 0x03,
   0xe0, 0x81, 0x81, 0x07, 0x20, 0x80, 0x01, 0x04, 0x00, 0x80, 0x01, 0x00,
   0x00, 0x80, 0x01, 0x00, 0x00, 0x80, 0x01, 0x00, 0x00, 0xc0, 0x03, 0x00,
   0x00, 0xc0, 0x03, 0x00, 0x00, 0xc0, 0x03, 0x00, 0x00, 0xc0, 0x03, 0x00,
   0x00, 0xc0, 0x03, 0x00, 0x00, 0xc0, 0x03, 0x00, 0x00, 0xc0, 0x03, 0x00,
   0x00, 0xc0, 0x03, 0x00, 0x00, 0x80, 0x01, 0x00 
};

const uint8_t wind2[] PROGMEM = {
   0x00, 0x00, 0x08, 0x00, 0x00, 0x00, 0x0c, 0x00, 0x00, 0x00, 0x0c, 0x00,
   0x00, 0x00, 0x0e, 0x00, 0x00, 0x00, 0x06, 0x00, 0x00, 0x00, 0x07, 0x00,
   0x00, 0x00, 0x07, 0x00, 0x00, 0x80, 0x07, 0x00, 0x00, 0x80, 0x07, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0xc0, 0x01, 0x00, 0x00, 0xde, 0x01, 0x00,
   0xc0, 0xdf, 0x01, 0x00, 0xf0, 0x9f, 0x04, 0x00, 0x68, 0x01, 0x0f, 0x00,
   0x00, 0x00, 0x1e, 0x00, 0x00, 0x80, 0x1f, 0x00, 0x00, 0x80, 0x39, 0x00,
   0x00, 0x80, 0x71, 0x00, 0x00, 0x80, 0x61, 0x00, 0x00, 0x80, 0xc1, 0x00,
   0x00, 0x80, 0x01, 0x00, 0x00, 0x80, 0x01, 0x00, 0x00, 0xc0, 0x03, 0x00,
   0x00, 0xc0, 0x03, 0x00, 0x00, 0xc0, 0x03, 0x00, 0x00, 0xc0, 0x03, 0x00,
   0x00, 0xc0, 0x03, 0x00, 0x00, 0xc0, 0x03, 0x00, 0x00, 0xc0, 0x03, 0x00,
   0x00, 0xc0, 0x03, 0x00, 0x00, 0x80, 0x01, 0x00
};

const uint8_t wind3[] PROGMEM = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x01, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x07, 0x00, 0x00,
   0x00, 0x0e, 0x00, 0x00, 0x00, 0x1e, 0x00, 0x00, 0x00, 0x3c, 0x00, 0x00,
   0x00, 0x3c, 0x00, 0x00, 0x00, 0x38, 0x00, 0x00, 0x00, 0xc0, 0x3c, 0x00,
   0x00, 0xe0, 0xfd, 0x07, 0x00, 0xe0, 0xfc, 0x03, 0x00, 0xc0, 0x0c, 0x00,
   0x00, 0x18, 0x00, 0x00, 0x00, 0xf8, 0x01, 0x00, 0x00, 0xb8, 0x01, 0x00,
   0x00, 0xbc, 0x01, 0x00, 0x00, 0x9c, 0x01, 0x00, 0x00, 0x8c, 0x01, 0x00,
   0x00, 0x86, 0x01, 0x00, 0x00, 0x86, 0x01, 0x00, 0x00, 0xc2, 0x03, 0x00,
   0x00, 0xc0, 0x03, 0x00, 0x00, 0xc0, 0x03, 0x00, 0x00, 0xc0, 0x03, 0x00,
   0x00, 0xc0, 0x03, 0x00, 0x00, 0xc0, 0x03, 0x00, 0x00, 0xc0, 0x03, 0x00,
   0x00, 0xc0, 0x03, 0x00, 0x00, 0x80, 0x01, 0x00 
};

const uint8_t wind4[] PROGMEM = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0x00, 0x00, 0x0c, 0x00, 0x00,
   0x00, 0x0c, 0x00, 0x00, 0x00, 0x1c, 0x00, 0x00, 0x00, 0x18, 0x00, 0x00,
   0x00, 0x38, 0x00, 0x00, 0x00, 0x38, 0x00, 0x00, 0x00, 0x78, 0x00, 0x00,
   0x00, 0x70, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe0, 0x0c, 0x00,
   0x00, 0xe0, 0x7d, 0x00, 0x00, 0xe0, 0xfc, 0x03, 0x00, 0x18, 0xfc, 0x07,
   0x00, 0x3c, 0x00, 0x00, 0x00, 0xbc, 0x01, 0x00, 0x00, 0x9e, 0x01, 0x00,
   0x00, 0x8e, 0x01, 0x00, 0x00, 0x87, 0x01, 0x00, 0x80, 0x83, 0x01, 0x00,
   0x80, 0x81, 0x01, 0x00, 0x00, 0x80, 0x01, 0x00, 0x00, 0xc0, 0x03, 0x00,
   0x00, 0xc0, 0x03, 0x00, 0x00, 0xc0, 0x03, 0x00, 0x00, 0xc0, 0x03, 0x00,
   0x00, 0xc0, 0x03, 0x00, 0x00, 0xc0, 0x03, 0x00, 0x00, 0xc0, 0x03, 0x00,
   0x00, 0xc0, 0x03, 0x00, 0x00, 0x80, 0x01, 0x00 
};

//resistor icons

const uint8_t resistor1[] PROGMEM = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x60, 0x30, 0x18, 0x00, 0x60, 0x30, 0x18, 0x00, 0x90, 0x48, 0x24, 0x00,
   0x90, 0x48, 0x24, 0x00, 0x08, 0x85, 0x42, 0x00, 0x08, 0x85, 0x42, 0x00,
   0x07, 0x02, 0x81, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00 
};

const uint8_t resistor3[] PROGMEM = {
   0x01, 0x02, 0x04, 0x00, 0x01, 0x02, 0x04, 0x00, 0x01, 0x02, 0x04, 0x00,
   0x06, 0x0c, 0x18, 0x00, 0x18, 0x30, 0x60, 0x00, 0x60, 0xc0, 0x80, 0x01,
   0x60, 0xc0, 0x80, 0x01, 0x18, 0x30, 0x60, 0x00, 0x06, 0x0c, 0x18, 0x00,
   0x01, 0x02, 0x04, 0x00, 0x06, 0x0c, 0x18, 0x00, 0x18, 0x30, 0x60, 0x00,
   0x60, 0xc0, 0x80, 0x01, 0x60, 0xc0, 0x80, 0x01, 0x18, 0x30, 0x60, 0x00,
   0x06, 0x0c, 0x18, 0x00, 0x01, 0x02, 0x04, 0x00, 0x06, 0x0c, 0x18, 0x00,
   0x18, 0x30, 0x60, 0x00, 0x60, 0xc0, 0x80, 0x01, 0x60, 0xc0, 0x80, 0x01,
   0x18, 0x30, 0x60, 0x00, 0x06, 0x0c, 0x18, 0x00, 0x01, 0x02, 0x04, 0x00,
   0x01, 0x02, 0x04, 0x00, 0x01, 0x02, 0x04, 0x00, 0x01, 0x02, 0x04, 0x00
};




   
#endif

